
//some experiments for the cheap 1.8 tft display working with the ESP32

#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library for ST7735
#include <SPI.h>
#include <DHT.h>
#include "Arduino.h"
#include "uRTCLib.h"
#include <ESP32Servo.h>


//Pin for ESP32
  #define TFT_CS         5  //case select connect to pin 5
  #define TFT_RST        15 //reset connect to pin 15
  #define TFT_DC         32 //AO connect to pin 32  (not sure that this is really used)  try pin 25
  #define TFT_MOSI       23 //Data = SDA connect to pin 23
  #define TFT_SCLK       18 //Clock = SCK connect to pin 18
  #define DHT11_PIN  21 // ESP32 pin GPIO21 connected to DHT11 sensor

static const int servoPin1 = 11;
Servo servo1;
static const int servoPin2 = 10;
Servo servo2;
static const int servoPin3 = 9;
Servo servo3;
static const int servoPin4 = 12;
Servo servo4;
static const int servoPin5 = 27;
Servo servo5;

int analogPin = 26;
int val = 0;
int oldvalue = 0;

// For ST7735-based displays, we will use this call
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_MOSI, TFT_SCLK, TFT_RST);

uRTCLib rtc(0x68);
char daysOfTheWeek[7][12] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};

DHT dht11(DHT11_PIN, DHT11);
//powering the tft display...

//GND is GND  that is the easy one
//LED pin on TFT will control brightness.  Using DAC on the ESP32 can control brightness by connecting
//to this pin.  See code below.  If this pin is high, VCC on the TFT does not need to be connected, but
//things seem to work better when it is connected.  VCC can go to either the 3.3 volt or the 5 volt (Vin)
//of the ESP32.  There does not appear to be any appreciable brightness difference when 5v is used instead of 3.3
//But the screen is brightest when 3.3 volts for VCC and 5volts for LED.

  int button1 = 13;
  int button2 = 14;
  int pageNumber = 1;
  int gestureNumber = 1;

  int period = 1000;
  unsigned long time_now = 0;

void setup(void) {
  pinMode(button1, INPUT_PULLUP);
  pinMode(button2, INPUT_PULLUP);

  Serial.begin(115200);
  // Use this initializer if using a 1.8" TFT screen:
  tft.initR(INITR_BLACKTAB);      // Init ST7735S chip, black tab
  dht11.begin();

  URTCLIB_WIRE.begin();
  rtc.set(0, 56, 12, 5, 13, 1, 22);

  Serial.println("Initialized");

  servo1.attach(servoPin1);
  servo2.attach(servoPin2);
  servo3.attach(servoPin3);
  servo4.attach(servoPin4);
  servo5.attach(servoPin5);

  tft.setRotation(1);
  tft.fillScreen(ST77XX_BLACK);
  int w = tft.width();
  int h = tft.height();
  Serial.print("width =");
  Serial.println(w);
  Serial.print("height =");
  Serial.println(h);
//expecting 128 x 160

}//end of void setup


/**
 Possible colors that are predefined...
 
ST7735_BLACK ST77XX_BLACK
ST7735_WHITE ST77XX_WHITE
ST7735_RED ST77XX_RED
ST7735_GREEN ST77XX_GREEN
ST7735_BLUE ST77XX_BLUE
ST7735_CYAN ST77XX_CYAN
ST7735_MAGENTA ST77XX_MAGENTA
ST7735_YELLOW ST77XX_YELLOW
ST7735_ORANGE ST77XX_ORANGE

*/

void loop() {
  rtc.refresh();
    // read humidity
  int humi  = dht11.readHumidity();
  int humi1 = 0;
  // read temperature in Celsius
  int tempC = dht11.readTemperature();
  int tempC1 = 0;
  // read temperature in Fahrenheit
  int tempF = dht11.readTemperature(true);
  
  if (digitalRead(button1)==0)
  {
    if (pageNumber>2)
    {
      pageNumber=1;
      tft.fillScreen(ST77XX_BLACK);
      delay(3);
    }
    else
    {
      pageNumber+=1;
      tft.fillScreen(ST77XX_BLACK);
      delay(3);
    }
  }

  Serial.println(val);

  if (val>3000)
  {
    if (gestureNumber==1)
    {
      servo1.write(180);
      servo2.write(180);
      servo3.write(180);
      servo4.write(180);
      servo5.write(180);
    }

    if (gestureNumber==2)
    {
      servo1.write(0);
      servo2.write(0);
      servo3.write(0);
      servo4.write(180);
      servo5.write(180);
    }

    if (gestureNumber==3)
    {
      servo1.write(0);
      servo2.write(180);
      servo3.write(180);
      servo4.write(0);
      servo5.write(0);
    }
  }

  servo1.write(0);
  servo2.write(0);
  servo3.write(0);
  servo4.write(0);
  servo5.write(0);

  int w = tft.width();
  int h = tft.height();

  if(pageNumber==1)
  {
    tft.setTextWrap(false);
    tft.setCursor(0, 0);
    tft.setTextColor(ST77XX_WHITE);
    tft.setTextSize(2);
    tft.println("Choose hand");
    tft.println("gesture");
    tft.println("");

    if (digitalRead(button2)==0)
    {
      if (gestureNumber>3)
      {
        gestureNumber=1;
        delay(3);
      }
      else
      {
        gestureNumber+=1;
        delay(3);
      }
    }

    if (gestureNumber==1)
    {
      tft.setTextColor(ST77XX_RED);
      tft.println("Gesture #1");
      tft.setTextColor(ST77XX_WHITE);
      tft.println("Gesture #2");
      tft.println("Gesture #3");
    }

    if (gestureNumber==2)
    {
      tft.println("Gesture #1");
      tft.setTextColor(ST77XX_RED);
      tft.println("Gesture #2");
      tft.setTextColor(ST77XX_WHITE);
      tft.println("Gesture #3");
    }

    if (gestureNumber==3)
    {
      tft.println("Gesture #1");
      tft.println("Gesture #2");
      tft.setTextColor(ST77XX_RED);
      tft.println("Gesture #3");
      tft.setTextColor(ST77XX_WHITE);
    }

    delay(1);
  }   

  if(pageNumber==2)
  {
    tft.setTextWrap(false);
    tft.setCursor(0, 0);
    tft.setTextColor(ST77XX_WHITE);
    tft.setTextSize(2);
    
    if(humi1!=humi)
    {
      tft.fillScreen(ST77XX_BLACK);
    }

    if(tempC1!=tempC)
    {
      tft.fillScreen(ST77XX_BLACK);
    }

    Serial.print(rtc.hour());
    Serial.print(":");
    Serial.print(rtc.minute());
    Serial.print(":");
    Serial.println(rtc.second());

    tft.println("Date & Time:");
    tft.print(rtc.day());
    tft.print("/");
    tft.print(rtc.month());
    tft.print("/");
    tft.print(rtc.year());
    tft.print(" ");
    tft.print(rtc.hour());
    tft.print(":");
    tft.println(rtc.minute());
    tft.println("");

    tft.println("Temperature:");
    tft.print(tempC);
    tft.print(char(248));
    tft.println("C");
    tft.println("");

    tft.println("Humidity:");
    tft.print(humi);
    tft.println("%");

    humi1 = humi;
    tempC1 = tempC;

    delay(3000);
  }   

  if(pageNumber==3)
  {
    tft.setTextWrap(false);
    tft.setCursor(0, 0);
    tft.setTextColor(ST77XX_WHITE);
    tft.setTextSize(2);
    tft.println("Battery");
    tft.println("life: ");

    tft.drawRect(60, 50, 50, 90, ST77XX_WHITE);
    tft.drawRect(75, 40, 20, 10, ST77XX_WHITE);

    tft.fillRect(61, 50, 48, 28, ST77XX_GREEN);
    tft.fillRect(61, 77, 48, 28, ST77XX_YELLOW);
    tft.fillRect(61, 105, 48, 28, ST77XX_RED);

    delay(1);
  }
}//end of void loop